<?php


/**
 * Filtre pour afficher une image à partir du nom de fichier
 * 
 * Le chemin complet du fichier (résultat API) peut être utilisé pour les catégories (utilise l'ancienne méthode de stockage des documents)
 * @param unknown $filepath
 * @param unknown $modulepart
 * @return string
 */
function dolispip_affiche_image($filepath, $modulepart) {
    include_spip('inc/documents');
    if(in_array($modulepart, array('category','product'))) {
	    $useGenericUser = true;
    }
    $var_mode = _request('var_mode');
    
	// Get full path of image (old mode for category)
	if($modulepart == 'category') {
	    $dolibarrPath = lire_config('dolispip/dolibarr_document_path').'categorie';
	    $length = strlen($dolibarrPath);
	    $filepath = substr($filepath, $length);
	}
	
	$dir_upload = _DIR_TRANSFERT;
	$filename = basename($filepath);
	$subdirectory = str_replace('/photos', '', dirname($filepath));
	$tmp_file = $dir_upload.basename($filepath);

	$destpath = sous_repertoire(_DIR_IMG. $modulepart, $subdirectory);
	$destfile = $destpath.$filename;

	// With var_mode=recalcul perform API call to update it
	if(file_exists($destfile)) {
	    if ($var_mode != 'recalcul') {	        
    	    return filtre_balise_img_dist($destfile);
	    }
	}
	 
	$file_download = dolispip_get_file($modulepart, $filepath, 0, $useGenericUser);
	if (is_object($file_download)) {

		$file = $file_download->content;
		if(!empty($file)){
		    
		    $data = base64_decode($file);
		    $success = file_put_contents($tmp_file, $data);
		    if($success) {
		       $res = deplacer_fichier_upload($tmp_file, $destfile, true);
		       if ($res) {
		           return filtre_balise_img_dist($destfile);
		       }
		    }
		    
			// Détection du user-agent histoire de savoir à quel navigo on a affaire
			$userAgent = strtolower($_SERVER['HTTP_USER_AGENT']);

			// On check si on est pas en présence d'une version antérieure à IE8
			if (preg_match("#(msie)[/ ]?([0-9.]*)#", $userAgent, $match))
			{
				// Version antérieure à 8
				if($match[2] < 8)
				{
					$msie = true;
				}
			}
			// Si c'est pas un Dynobrowser on applique le filtre
			if ( $msie != true )
			{
				// Retourne le type de contenu au format MIME
				//$mime = mime_content_type($src);
				$mime = $file_download->mimetype;

				// Passage de l'image en base64 et préparation du nouveau src
				$src = "data:".$mime.";base64," . $file;

				// Enfin on remplace le src par notre version en base64
				//$file = inserer_attribut($file,"src",$src);
				$file = '<img src="'.$src.'" />';
			}
		}
		return $file;
	}
	return '';
}


/**
 *  Récupère un document PDF en webservice
 *  @param	modulepart	string	type of document (propal / facture / commande)
 *  @param	ref			string	ref/name of file
 */
function dolispip_get_document($modulepart, $id = '', $ref = '', $regeneratedoc = 0, $sortfield = '', $sortorder = '', $useGenericUser=true) {

    if(!$id && !$ref)
        return '';
    
	include_spip('inc/config');
	include_spip('inc/dolispip');

	if($ref) {
	   $relativepath = $ref.'/'.$ref.'.pdf';
       $subdir = $ref;
	}
	$params = array('module_part'=>$modulepart,'original_file'=>$relativepath, 'regeneratedoc' => $regeneratedoc);

	$endpoint = 'documents/download';
	$res = getDolibarrApi($endpoint, $params, $useGenericUser);
	return $res;
}

/**
 *  Récupère un fichier en webservice
 *  @param	modulepart	  string	type of document (propal / facture / commande)
 *  @param	relativepath    string	filepath of file
 */
function dolispip_get_file($modulepart, $relativepath, $regeneratedoc = 0, $useGenericUser=true) {
    
    if(!$modulepart && !$relativepath)
        return '';
        
    include_spip('inc/config');
    include_spip('inc/dolispip');
    $params = array('module_part' => $modulepart, 'original_file' => $relativepath, 'regeneratedoc' => $regeneratedoc);
    
    $endpoint = 'documents/download';
    $res = getDolibarrApi($endpoint, $params, $useGenericUser);
    return $res;
}

/**
 *  Récupère les documents d'un objet
 *  @param	modulepart	string	type of document (propal / facture / commande)
 *  @param	ref			string	ref/name of file
 *  @param $useGenericUser
 */
function dolispip_get_list_documents($modulepart, $id='', $ref='', $useGenericUser=1) {
    
    if(!$id && !$ref)
        return '';
        
    include_spip('inc/config');
    include_spip('inc/dolispip');
        
    if($ref) {
        $relativepath = $ref.'/'.$ref.'.pdf';        
    }
        
    $endpoint = 'documents/';
    $params = array('modulepart'=>$modulepart,'id' => $id, 'ref'=>$ref, 'sortfield' => 'name', 'sortorder' => 'asc');        
    $res = getDolibarrApi($endpoint, $params, $useGenericUser);
 
    return $res;
}


function objectToArray( $object )
{
    if( !is_object( $object ) && !is_array( $object ) )
    {
        return $object;
    }
    if( is_object( $object ) )
    {
        $object = get_object_vars( $object );
    }
    return array_map( 'objectToArray', $object );
}
