<?php

/*
 *
 *
 * Crée une propale à partir du panier
 *
 * param @thirparty array
 * return socid
 *
 */
include_spip('inc/dolispip');

/*
 *
 * Retourne un objet à convertir en tableau si besoin avec get_object_vars()
 *
 */
function dolispip_get_infos_event($id, $ref = "",$use_user=false) {
	include_spip('inc/config');
	
	if(lire_config('dolispip/dolibarr_rep_custom'))
		$custom = lire_config('dolispip/dolibarr_rep_custom').'/';
	
	$WS_DOL_URL = lire_config('dolispip/dolibarr_url') . $custom.'event/webservices/server_event.php?wsdl';

	$WS_METHOD = 'getEventInfos';

	$params = array('id' => $id, 'ref' => $ref, 'nbmaxphoto' => "0");

	$result = doSoapCall($WS_METHOD, $params, $WS_DOL_URL,$use_user,1);

	if (!$result)
	{
		//var_dump($soapclient);
		print '<h2>Erreur SOAP 1</h2>' . $soapclient -> error_str;
		exit ;
	}

	// On vire le code de retour result
	unset($result['result']);
	
	return $result;
}


/*
 *
*
* Créer une inscription dans Dolibarr
*
* param @registration array
* return registration_id
*
*/
function dolispip_event_creer_inscription($registration) {
	include_spip('inc/dolispip');
	include_spip('inc/session');
	
	if(lire_config('dolispip/dolibarr_rep_custom'))
		$custom = lire_config('dolispip/dolibarr_rep_custom').'/';
	
	$WS_DOL_URL = lire_config('dolispip/dolibarr_url').$custom.'event/webservices/server_event.php?wsdl';
	$WS_METHOD  = 'createRegistration';

	$parameters = array('registration'=>$registration);
	// Si connecté on crée l'inscription avec l'utilisateur 
	$use_user = session_get('doli_socid') > 0 ? 1:0;
	$result = doSoapCall($WS_METHOD,$parameters,$WS_DOL_URL,$use_user,1);

	if (! $result &&  $result['result_code'] != 'OK')
	{
		var_dump($soapclient);
		print '<h2>Erreur SOAP 1</h2>'.$soapclient->error_str;
		return false;

	}

	return $result['id'];
}


/*
 *
* Retourne les infos d'une inscription
*
*/
function dolispip_get_infos_registration($id, $ref = "",$use_user=false) {
	include_spip('inc/config');
	if(lire_config('dolispip/dolibarr_rep_custom'))
		$custom = lire_config('dolispip/dolibarr_rep_custom').'/';
	$WS_DOL_URL = lire_config('dolispip/dolibarr_url') . $custom.'event/webservices/server_event.php?wsdl';

	$WS_METHOD = 'getRegistration';


	$params = array('id' => $id, 'ref' => $ref);

	$result = doSoapCall($WS_METHOD, $params, $WS_DOL_URL,1,0);
	if (!$result)
	{
		//var_dump($soapclient);
		print '<h2>Erreur SOAP 1</h2>' . $soapclient -> error_str;
		exit ;
	}

	// On vire le code de retour result
	unset($result['result']);

	return $result;
}

// decale les jours de la date.
function dolispip_jourdecal($date,$decalage,$format){
	include_spip('inc/filtres');
	$date_array = recup_date($date);
	if ($date_array) list($annee, $mois, $jour) = $date_array;
	if (!$jour) $jour=1;
	if (!$mois) $mois=1;
	$jour2 = $jour + $decalage;
	$date2 = mktime(1, 1, 1, $mois, $jour2, $annee);
	return date($format, $date2);
}

// Récupère un document en webservice
function dolispip_get_registration_pdf($ref) {
	if(!$ref)
		return '';
	
	include_spip('inc/config');
	if(lire_config('dolispip/dolibarr_rep_custom'))
		$custom = lire_config('dolispip/dolibarr_rep_custom').'/';
	$WS_DOL_URL = lire_config('dolispip/dolibarr_url') . $custom.'event/webservices/server_event.php?wsdl';
	
	$WS_METHOD = 'getRegistrationPdf';
	
	
	$params = array('ref' => $ref);
	
	$result = doSoapCall($WS_METHOD, $params, $WS_DOL_URL,1,1);
	
	if (!$result)
	{
		//var_dump($soapclient);
		print '<h2>Erreur SOAP 1</h2>' . $soapclient -> error_str;
		exit ;
	}
	
	// On vire le code de retour result
	unset($result['result']);
	
	return $result['registration_pdf'];
}
	
	
