<?php

/*
 *
 *
 * Crée un paiement à partir d'une facture
 *
 */
include_spip('inc/dolispip');

/*
 * Création d'un paiement avec les webservices Dolibarr
 */
function dolispip_creer_payment($id_facture,$amount) {

    // Le visiteur en cours
    $id_auteur = session_get('id_auteur') > 0 ? session_get('id_auteur') : 0;
    $socid = session_get('doli_socid');    
    
    //Store payment
    $WS_DOL_URL = lire_config('dolispip/dolibarr_url').'webservices/server_payment.php?wsdl';
    $WS_METHOD  = 'createPayment';
    
    $payment = new stdClass();
    $payment->amount = $amount;
    $payment->invoice_id = $id_facture;
    $payment->thirdparty_id = $socid;
    $payment->num_paiement = lire_config('dolispip_payments/num_paiement','');
    $payment->bank_account = lire_config('dolispip_payments/bank_account',1);
    $payment->payment_mode_id = lire_config('dolispip_payments/payment_mode_id_default',1);
    $payment->int_label = lire_config('dolispip_payments/','DoliSPIP');
    $payment->emitter = lire_config('dolispip_payments/emitter','DoliSPIP');
    $payment->bank_source = lire_config('dolispip_payments/bank_source','DoliSPIP');
    
    $params = array('payment'=>$payment);

    $result = doSoapCall($WS_METHOD, $params, $WS_DOL_URL);    
    
    if (! $result &&  $result['result_code'] != 'OK') {
        //var_dump($soapclient);
        print '<h2>Erreur SOAP 1</h2>'.$soapclient->error_str;
        return false;
    } else {
        return $result['id'];
    }
            
}
