<?php

// Sécurité
if (!defined('_ECRIRE_INC_VERSION')) {
  return;
}

/**
 * Remplir un panier avec un objet quelconque
 *
 * @param  unknown_type $arg
 * @return unknown_type
 */
function action_remplir_dolipanier_dist($arg=null)
{
    if (is_null($arg)) {
        $securiser_action = charger_fonction('securiser_action', 'inc');
        $arg = $securiser_action();
    }

    // On récupère les infos de l'argument avec la réf et la quantité
    $quantite = substr($arg, strrpos($arg, '-')+1);
    $product_ref = substr($arg, 0, strrpos($arg, '-')); // $arg sans quantite
    $quantite = intval($quantite) ? intval($quantite) : 1;

    include_spip('inc/dolipaniers');
    // Il faut chercher le panier du visiteur en cours
    $id_panier = paniers_id_dolipanier_encours();
    // S'il n'y a pas de panier, on le crée
    if (!$id_panier) {
        $id_panier = dolipaniers_creer_panier();

    }



	// On ne fait que s'il y a bien un panier existant et un objet valable
	if ($id_panier > 0 and $product_ref) {
		// Il faut maintenant chercher si cet objet précis est *déjà* dans le panier
		$quantite_deja = intval(sql_getfetsel(
			'quantite',
			'spip_dolipaniers_liens',
			array(
				'id_dolipanier = '.$id_panier,
				'product_ref = '.sql_quote($product_ref)
			)
		));
		// Récup des infos du produit
		include_spip('dolispip_produits_fonctions');
		// TODO : utiliser l'utilisateur actuellement connecté
		// permettrait d'utiliser les différentes règles de prix (multiprix / prix par client, …)
		$useGenericUser = true;
		$doliproduct = dolispip_get_infos_produit('', $product_ref, $useGenericUser);
		// Si on a déjà une quantité, on fait une mise à jour
		if ($quantite_deja){
			sql_updateq(
				'spip_dolipaniers_liens',
				array('quantite' => $quantite_deja + $quantite,'product_price_net'=>$doliproduct->price),
				'id_dolipanier = '.$id_panier.' and product_ref = '.sql_quote($doliproduct->ref)
			);
		}
		// Sinon on crée le lien
		else{
			sql_insertq(
				'spip_dolipaniers_liens',
				array(
					'id_dolipanier' => $id_panier,
					'product_ref' => $product_ref,
					'product_label' => $doliproduct->label,
					'product_description' => $doliproduct->description,
					'product_price_net' => $doliproduct->price,
					'product_price' => $doliproduct->price_ttc,
					'product_vat_rate' => $doliproduct->tva_tx,
					'quantite' => $quantite
				)
			);
		}

        // Mais dans tous les cas on met la date du panier à jour
        sql_updateq(
            'spip_dolipaniers',
            array('date'=>'NOW()'),
            'id_dolipanier = '.$id_panier
        );

    }
}
