<?php
if (!defined("_ECRIRE_INC_VERSION")) {
   return;
}


function dolispip_produits_declarer_tables_principales($tables_principales)
{
    // Extension de la table rubriques
    $tables_principales['spip_articles']['field']['doli_catid'] = "bigint(21) DEFAULT 0";
    $tables_principales['spip_rubriques']['field']['doli_catid'] = "bigint(21) DEFAULT 0";

          // Un panier peut être "encours", "commande", "paye", "envoye", "retour", "retour_partiel"
    $dolipaniers = array(
    'id_dolipanier'   => "bigint(21) NOT NULL",
    'id_auteur'   => "bigint(21) NOT NULL DEFAULT 0",
    'cookie'      => "varchar(255) NOT NULL DEFAULT ''",
    'statut'      => "varchar(20) NOT NULL DEFAULT 'encours'",
    'date'        => "datetime NOT NULL DEFAULT '0000-00-00 00:00:00'",
    'maj'         => "TIMESTAMP"
    );

    $dolipaniers_cles = array(
    'PRIMARY KEY' => 'id_dolipanier'
    );

    $tables_principales['spip_dolipaniers'] = array(
    'field'       => &$dolipaniers,
    'key'         => &$dolipaniers_cles,
    'join'=> array(
    'id_dolipanier' => 'id_dolipanier'
    )
    );

    return $tables_principales;
}

function dolispip_produits_declarer_tables_interfaces($interface)
{
    // 'spip_' dans l'index de $tables_principales
    $interface['table_des_tables']['dolipaniers'] = 'dolipaniers';
    $interface['table_des_tables']['dolipaniers_liens'] = 'dolipaniers_liens';

    //-- Jointures ----------------------------------------------------
    $interface['tables_jointures']['spip_auteurs'][]= 'dolipaniers';

    $interface['table_date']['dolipaniers'] = 'date';

    return $interface;
}


function dolispip_produits_declarer_tables_auxiliaires($tables_auxiliaires)
{

    $tables_auxiliaires['spip_dolipaniers_liens'] = array(
    'field' => array(
    "id_dolipanier"          => "bigint(21) DEFAULT '0' NOT NULL",
    'product_ref' => 'varchar(255) not null default ""',
    'product_label' => 'varchar(255) not null default ""',
    'product_description' => 'varchar(255) not null default ""',
    'product_price_net' => 'double(24,8) not null default 0.00000000',
    'product_price' => 'double(24,8) not null default 0.00000000',
    'product_vat_rate' => 'double not null default 0.00',
    "quantite"           => "int DEFAULT '1' NOT NULL",
    ),
    'key' => array(
    "PRIMARY KEY"             => "id_dolipanier,product_ref",
    "KEY id_dolipanier"      => "id_dolipanier"
    )
    );



    return $tables_auxiliaires;
}
