<?php
/**
 *
 */

// Sécurité
if (!defined('_ECRIRE_INC_VERSION')) {
  return;
}

include_spip('inc/dolipaniers');
/**
 * [formulaires_dolispip_panier_charger description]
 * @param  integer $id_panier [description]
 * @return [type]             [description]
 */
function formulaires_dolispip_panier_charger($id_panier=0)
{
    include_spip('inc/session');


    // On commence par chercher le panier du visiteur actuel s'il n'est pas donné
    if (!$id_panier) { $id_panier = paniers_id_dolipanier_encours();
    }

    $contexte = array(
    '_id_panier' => $id_panier,
    'quantites' => array()
    );

    return $contexte;
}

/**
 * [formulaires_dolispip_panier_verifier description]
 * @param  integer $id_panier [description]
 * @return [type]             [description]
 */
function formulaires_dolispip_panier_verifier($id_panier=0)
{
    $erreurs = array();

    $quantites = _request('quantites');

    if (is_array($quantites)) {
        foreach($quantites as $ref => $quantite) {

            if (!is_numeric($quantite) or $quantite != intval($quantite) or (is_numeric($quantite) and $quantite < 0)) {
                $erreurs['message_erreur'] = _T('dolispip_produits:panier_erreur_quantites');
                $erreurs['quantites'][$ref] = 'erreur';
            }
        }
    }


    return $erreurs;
}

/**
 * [formulaires_dolispip_panier_traiter description]
 * @param  integer $id_panier [description]
 * @return [type]             [description]
 */
function formulaires_dolispip_panier_traiter($id_panier=0)
{
    $retours = array();

    // On commence par chercher le panier du visiteur actuel s'il n'est pas donné
    if (!$id_panier) { $id_panier = paniers_id_dolipanier_encours();
    }

    $quantites = _request('quantites');
    $ok = true;
    if (is_array($quantites)) {
        foreach($quantites as $ref => $quantite){
            $quantite = intval($quantite);
            // Si la quantite est 0, on supprime du panier
            if (!$quantite) {
                $ok &= sql_delete(
                    'spip_dolipaniers_liens',
                    'id_dolipanier = '.intval($id_panier).' and product_ref = '.sql_quote($ref)
                );
            }
            // Sinon on met à jour
            else{
                    $ok &= sql_updateq(
                        'spip_dolipaniers_liens',
                        array('quantite' => $quantite),
                        'id_dolipanier = '.intval($id_panier).' and product_ref = '.sql_quote($ref)
                    );
            }
        }
    }
    // Mais dans tous les cas on met la date du panier à jour
    sql_updateq(
        'spip_dolipaniers',
        array('date'=>'NOW()'),
        'id_dolipanier = '.$id_panier
    );

    if ($ok) {
        $retours['message_ok'] = _T('dolispip_produits:panier_quantite_ok');
    }

    return $retours;
}
