<?php

/*
 * 
 *
 * Crée une propale à partir du panier
 * 
 * param @thirparty array
 * return socid
 * 
 */
include_spip('inc/dolispip');

/**
 * Récupère la liste des propales
 *
 */
function dolispip_get_list_propales() {
    $endpoint = 'proposals';
    return getDolibarrApi($endpoint);
}

/**
 * Récupère les infos d'une propale
 *
 * @param int $idPropale
 * @param boolean $use_user
 * @return boolean|mixed|string
 */
function dolispip_get_infos_propale($idPropale, $use_user=false) {
    $endpoint = 'proposals/'.$idPropale;
    $res = getDolibarrApi($endpoint);
    return $res;
}

/**
 * Récupère les lignes d'une propale
 *
 * @param int $idPropale
 * @param boolean $use_user
 * @return boolean|mixed|string
 */
function dolispip_get_lines_propale($idPropale, $use_user=false) {
    $endpoint = "proposals/$idPropale/lines";
    $res = getDolibarrApi($endpoint);
    return $res;
}

/**
 * Création d'une propale avec l'API Dolibarr
 *
 * @param array $invoice  Tableau avec les infos de propale
 */
function dolispip_creer_propale_api($propale)
{
    $endpoint = 'proposals';
    $res = postDolibarrApi($endpoint, $propale, true);
    return $res;
}


function dolispip_creer_propale()
{
    include_spip('inc/session');
    
    // TODO: S'il y a une commande en cours dans la session, on la supprime
    // Le visiteur en cours
    $id_auteur = session_get('id_auteur') > 0 ? session_get('id_auteur') : 0;
    
    $socid = session_get('doli_socid');
    
    
    // Si on a un panier en cours
    if (include_spip('inc/dolipaniers')
        and $id_panier = paniers_id_dolipanier_encours()) {
            // On récupère le contenu du panier
            $panier = sql_allfetsel(
                'id_dolipanier, product_ref, product_label, quantite',
                'spip_dolipaniers_liens',
                'id_dolipanier = ' . $id_panier
                );
            
            // Pour chaque élément du panier, on va remplir la commande
            if ($panier and is_array($panier)) {
                include_spip('spip_bonux_fonctions');
                $fonction_prix = charger_fonction('prix', 'inc/');
                $fonction_prix_ht = charger_fonction('ht', 'inc/prix');
                
                $propal = load_propale_array();
                
                /*
                 * Propriété propale
                 */
                $propal['socid'] = $socid;
                $propal['date'] = mktime(date('H'), date('i'), date('s'), date('m'), date('j'), date('Y'));
                
                $propal['contactid'] = '';
                $propal['fk_project'] = '';
                $propal['author'] = '';
                
                $propal['user_author_id'] = '';
                
                $propal['cond_reglement_id'] = "1"; // A réception
                $propal['cond_reglement_code'] = '';
                
                $propal['fk_delivery_address'] = '';
                $propal['fk_address'] = '';
                
                $propal['address_type'] = '';
                $propal['adresse'] = '';
                
                $propal['duree_validite'] = '30';
                
                
                $products = array();
                foreach ($panier as $emplette) {
                    
                    include_spip('dolispip_produits_fonctions');
                    $doliproduct = dolispip_get_infos_produit('', $emplette['product_ref'], true);
                    if(!$doliproduct->ref)
                        $line['desc'] = $doliproduct->label;
                    else $line['desc'] = '';
                        
                    $line['qty'] = $emplette['quantite'];
                        
                    $line['price'] = $doliproduct->price;
                    $line['subprice'] = $doliproduct->price;
                    
                    $line['tva_tx'] =  $doliproduct->tva_tx;
                    $line['remise'] = '';
                    $line['remise_percent'] = $line_remise_percent;
                    //$line['total']= $doliproduct->price * $line['qty'];
                    $line['total_vat'] = '';
                    $line['total'] = $doliproduct->price * $line['qty'];
                    
                   
                    
                    $line['product_type'] = $doliproduct->type;
                    $line['product_id'] = $doliproduct->id; // TODO: deprecated
                    $line['fk_product'] = $doliproduct->id;
                    $line['product_ref'] = $doliproduct->ref;
                    $line['product_label'] = $doliproduct->label;
                    $line['product_desc'] = $doliproduct->description;
                    
                    // Remplissage de la commande avec les lignes
                    $propal['lines'][] = $line;
  
                }
                
                $result = dolispip_creer_propale_api($propal);
                
                if (!$result) {
                    print '<h2>Erreur API 1</h2>';
                    return false;
                }
                
                return $result;
            }
        } 
}

function load_propale_array()
{

    $propal = array();

    $propal['id'] = '';
    $propal['socid'] = '';
    $propal['client'] = '';
    $propal['contactid'] = '';
    $propal['fk_project'] = '';
    $propal['author'] = '';
    $propal['ref'] = '';
    $propal['ref_client'] = '';
    $propal['statut'] = 0;
    $propal['datec'] = '';
    $propal['datev'] = '';
    $propal['date'] = '';
    $propal['datep'] = '';
    $propal['date_livraison'] = '';
    $propal['fin_validite'] = '';
    $propal['user_author_id'] = '';
    $propal['user_valid_id'] = '';
    $propal['user_close_id'] = '';
    $propal['total_ht'] = '';
    $propal['total_tva'] = '';
    $propal['total_localtax1'] = '';
    $propal['total_localtax2'] = '';
    $propal['total_ttc'] = '';
    $propal['price'] = '';
    $propal['tva'] = '';
    $propal['total'] = '';
    //$propal['cond_reglement_id'] = "1"; // A réception
    $propal['cond_reglement_code'] = 'CMD';
    $propal['mode_reglement_id'] = '0';
    $propal['mode_reglement_code'] = '';
    $propal['remise'] = '0';
    $propal['remise_percent'] = '0';
    $propal['remise_absolue'] = '';
    $propal['note'] = '';
    $propal['note_public'] = '';
    $propal['fk_delivery_address'] = '';
    $propal['fk_address'] = '';
    $propal['address_type'] = '';
    $propal['adresse'] = '';
    $propal['availability_id'] = '';
    $propal['availability_code'] = '';
    $propal['demand_reason_id'] = '1'; // 1: internet
    $propal['demand_reason_code'] = '';
    $propal['products'] = array();
    $propal['lines'] = '';
    $propal['line'] = '';
    $propal['origin'] = '';
    $propal['origin_id'] = '';
    $propal['labelstatut'] = '';
    $propal['labelstatut_short'] = '';
    $propal['objectid'] = '';

    $propal['duree_validite'] = '30';

    return $propal;
}
