<?php

// Sécurité
if (!defined('_ECRIRE_INC_VERSION')) return;


function formulaires_doliticket_charger($ref=''){
	include_spip('inc/session');

	$sujet ="";
	$message = "Bonjour,\n\n";
	if(strlen($ref) > 0) {
		include_spip('dolispip_tickets_fonctions');
		$ticketData = dolispip_get_ticket($ref);
		$sujet = "Re: Ticket ".$ticketData['ref']." : ";
		$message = '';
	}
	$contexte = array(
		'ref' => $ref,
		'track_id' => $ticketData['track_id'],
		'type_code'=>$type_code,
		'category_code'=>$category_code,
		'severity_code'=>$severity_code,
		'subject'=>$sujet,
		'message'=> $message,
		'email' => session_get('email'),
		'editable'=>true
	);

	return $contexte;
}

function formulaires_doliticket_verifier($ref=''){
	$erreurs = array();

	$obligatoires = array('message');
    foreach($obligatoires as $champ) {
        if (!_request($champ)) {
            $erreurs[$champ] = "Cette information est obligatoire !";
        }
    }

    if (count($erreurs)) {
        $erreurs['message_erreur'] = "Une erreur est présente dans votre saisie";

    }

	return $erreurs;
}

function formulaires_doliticket_traiter($ref=''){
	include_spip('inc/config');
	include_spip('inc/session');
	$retours = array();
	$ticket['id'] = '0';
	$ticket['ref'] = $ref;
	$ticket['element'] = 'ticketsup';
	$ticket['track_id'] = _request('track_id');
	$ticket['fk_soc'] = session_get('doli_socid');
	$ticket['subject'] = utf8_encode(_request('subject'));
	$ticket['message'] = _request('message');
	$ticket['origin_email'] = _request('email');
	$ticket['fk_statut'] = '0';

	$ticket['statuts_short'] = '0';
	$ticket['progress'] = '0';
	$ticket['type_code'] = _request('type_code');
	$ticket['category_code'] = _request('category_code');
	$ticket['severity_code'] = _request('severity_code');

	/*
	 *  Création du ticket ou du message
	 */

	// Ticket déjà existant : on enregistre un message.
	 if(strlen($ticket['ref']) > 8)
	 {
		$track_id = creer_ticket_message($ticket);
		if($track_id)
		{
			// Création nouveau ticket
			/*
			 * Envoyer un mail à l'admin et à l'internaute
			 */
			$ok = true;
		}
	}
	else
	{

	    $idticket = creer_ticket($ticket);
	    if($idticket)
		{
			$ok = true;


			/* Envoi du mail infos à l'admin */
			$email_adminto = $GLOBALS['meta']['email_webmaster'];
			$email_userto = $email_from_admin = session_get('email');

			$email_from = lire_config('dolispip_tickets/email_from');
			$nom_site = supprimer_tags(extraire_multi($GLOBALS['meta']['nom_site']));

			$sujet_admin = "[$nom_site] ". _T('dolipip_tickets:email_sujet_nouveau_ticket_admin');
			$sujet_user = "[$nom_site] ". _T('dolispip_tickets:email_sujet_nouveau_ticket');


			$message_admin = "Nouveau ticket crée à partir du site.  \n";
			$message_admin .= "\n-------------------------------------------\n";
			$message_admin .= "Sujet : \t ".$ticket['subject']." \n";
			$message_admin .= "Message : \t ".$ticket['message']." \n";

			$message_admin .= "Consulter le message : ".lire_config('dolispip/dolibarr_url')."/ticketsup/card.php?id=".$idticket;

			$message_admin .= "\n\n-------------------------------------------\n";
			$message_admin .= "Referer : \t" . $_SERVER['HTTP_REFERER'] . "\n";
			$message_admin .= "User Agent : \t" . $_SERVER['HTTP_USER_AGENT'] . "\n";
			$message_admin .= "hostname : \t" . $_SERVER['HTTP_HOST'] . "\n";
			$message_admin .= "IP : \t" . $_SERVER['REMOTE_ADDR'] . "\n";

			$message_admin .= "\n\n " . _T('envoi_via_le_site') . ' ' . $nom_site . ' (' . $GLOBALS['meta']['adresse_site'] . "/) \n";

			$envoyer_mail = charger_fonction('envoyer_mail','inc');
			$envoyer_mail($email_adminto,$sujet_admin,$message_admin,$email_from);

			$message_user = extraire_multi(lire_config('dolispip_tickets/texte_email_intro'));

			$message_user .= "\n-------------------------------------------\n";
			$message_user .= "Sujet : \t ".$ticket['subject']." \n";
			$message_user .= "Message : \t ".$ticket['message']." \n";
			$message_user .= "\n-------------------------------------------\n";

			$message_user = extraire_multi(lire_config('dolispip_tickets/texte_email_signature'));


			$message_user .= "\n\n " . _T('envoi_via_le_site') . ' ' . $nom_site . ' (' . $GLOBALS['meta']['adresse_site'] . "/) \n";

			$envoyer_mail = charger_fonction('envoyer_mail','inc');
			$envoyer_mail($email_userto,$sujet_user,$message_user,$email_from);
		}




	}

	if ($ok) {
		$redirect = generer_url_public('doliticket');

		$retours['message_ok'] = _T('dolispip_tickets:creation_ticket_reussie');
		$retours['editable']=false;
		//$retours['redirect'] = $redirect;
	}
	else {
		$retours['message_erreur'] = "Une erreur s'est produite";
	}

	return $retours;
}

/*
 *
 *
 * En distant le webservice crée un ticket
 *
 * param @ticket array
 * return socid
 *
 */
function creer_ticket($ticket) {
   include_spip('inc/dolispip');

   $endpoint = 'ticketsups';
   $res = doRestPost($endpoint, $ticket);

   if( !empty($res['error']) && ! empty($res['error']['code'])) {
       $res = array();
   }
  return $res;
}

/*
 *
 *
 * En distant le webservice crée un ticket
 *
 * param @ticket array
 * return socid
 *
 */
function creer_ticket_message($ticket) {
	$endpoint = 'ticketsups/newmessage';
	$res = doRestPost($endpoint, $ticket);

	if( !empty($res['error']) && ! empty($res['error']['code'])) {
			$res = array();
	}
 return $res;


}
