<?php


/*
 *
 *
 * En distant le webservice crée une fiche client et un contact
 *
 * param @thirparty array
 * return $id if OK, 0 if already exist, -1 if error/not create
 *
 */
function dolispip_tiers_creer_compte($thirdparty) 
{

    // Creer le compte tiers
    include_spip('inc/dolispip');
    $newCompany = $thirdparty;
    $newCompany['name'] = $thirdparty['name_thirdparty'];

    $endpoint = 'thirdparties';
    $newCompanyId = postDolibarrApi($endpoint, $newCompany, true);
    if($newCompanyId > 0) {

        $newContact = array(
        'lastname' => $thirdparty['name'],
        'firstname' => $thirdparty['firstname'],
        'address' => $thirdparty['address'],
        'zip' => $thirdparty['zip'],
        'town' => $thirdparty['town'],
        'phone_mobile' => $thirdparty['phone_mobile'],
        'phone_pro' => $thirdparty['phone'],
        'email' => $thirdparty['email'],
        'socid' => $newCompanyId
        );
        // creer le contact
        $endpoint = 'contacts';
        $newContactId = postDolibarrApi($endpoint, $newContact, true);
        if ($newContactId > 0) {

              // créer le compte utilisateur d'aprés le contact
              $endpoint = "contacts/$newContactId/createUser";
              $newUserId = postDolibarrApi($endpoint, array('login' => $thirdparty['login'], 'password' => $thirdparty['password']), true);
            if ($newUserId > 0) {

                // Assigne le groupe
                $endpoint = "users/$newUserId/setGroup/". lire_config('dolispip_tiers/group_for_users');
                $resGroup = getDolibarrApi($endpoint, array(), true);

                return $newCompanyId;
            } else {
                  spip_log("dolispip_tiers_creer_compte:: 1 erreur création user", 'dolispip'._LOG_DEBUG);
            }
      
        } else {
                spip_log("dolispip_tiers_creer_compte:: 2 erreur création contact", 'dolispip'._LOG_DEBUG);
        }
    }
    return 0;
}

/*
 *
*
* Créer un tiers dans Dolibarr
*
* param @thirparty array
* return socid
*
*/
function dolispip_tiers_creer_fiche($thirdparty) 
{
    include_spip('inc/dolispip');
    $endpoint = 'thirdparties';
    $res = postDolibarrApi($endpoint, $thirdparty);
    return $res;
}

// Surcharge la fonction du formulaire de contact pour y ajouter l'import d'un tiers dans Dolibarr
function formulaires_contact_traiter($id_auteur='',$tracer='')
{

    include_spip('base/abstract_sql');
    include_spip('inc/texte');

    $infos = '';

    // On récupère à qui ça va être envoyé
    $destinataire = _request('destinataire');
    if (!is_array($destinataire)) {
        $destinataire = array($destinataire);
    }
    $destinataire = array_map('intval', $destinataire);
    $mail = sql_allfetsel(
        'email',
        'spip_auteurs',
        'id_auteur IN ('.join(', ', $destinataire).')'
    );
    $mail = array_map('reset', $mail);
    // S'il n'y a pas le plugin facteur, on met l'(es) adresse(s) sous forme de chaine de caractères.
    if (!defined("_DIR_PLUGIN_FACTEUR")) {
        $mail = join(', ', $mail);
    }

    // Les infos supplémentaires
    $champs_possibles = contact_infos_supplementaires();
    $champs_mini_config = array('mail', 'sujet', 'texte');
    $champs_choisis = lire_config('contact/champs', $champs_mini_config);
    if (is_array($champs_choisis)) {
        foreach($champs_choisis as $champ){
            if ($reponse_champ = _request($champ)) {
                if(($champ=='mail') OR ($champ=='sujet') OR ($champ=='texte') ) {
                    $posteur[$champ] = $reponse_champ;
                }else{
                    $infos .= "\n".$champs_possibles[$champ]." : ".$reponse_champ;
                }
            }
        }
    }
    if($tracer) {
        $trace=explode('-', $tracer);
        if((count($trace)==2) and (intval($trace[1])>0) ) {
            $url = generer_url_entite(intval($trace[1]), $trace[0]);
            if($url) {
                $inforigine= $GLOBALS['meta']['adresse_site']."/".$url;
            }else{
                $inforigine= 'info trace non comprise';
            }
        }else{
            $inforigine= 'info trace non comprise';
        }
        $inforigine= _T('contact:inforigine')."\n".$inforigine."\n\n";

    }

    // horodatons
    $horodatage = affdate_heure(date("Y-m-d H:i:s"));
    $horodatage = "\n\n"._T('contact:horodatage', array('horodatage'=>$horodatage))."\n\n";
    $par = _T('contact:par').$posteur['mail']."\n\n";

    $texte = $horodatage.$par.$inforigine.$infos."\n\n".$posteur['texte'];
    $nom_site = supprimer_tags(extraire_multi($GLOBALS['meta']['nom_site']));
    $texte .= "\n\n "._T('envoi_via_le_site')." ".$nom_site." ( ".$GLOBALS['meta']['adresse_site']."/ ) \n";

    // Texte a envoyer par mail, sans raccourcis SPIP
    // On évite de couper les urls
    define('_MAX_LONG_URL', 100000);
    define('_MAX_COUPE_URL', 100000);
    $texte_final = propre($texte);
    // Eviter que le facteur machouille les apostrophes
    if ($GLOBALS['meta']['facteur_filtre_iso_8859']) {
        $texte_final = preg_replace(',&#8217;,', "'", $texte_final);
    }
    // Sauvegarder un soupcon de liste dans le mail
    $texte_final = preg_replace(array('/<li>/','/<\/li>/','/<\/ul>/'), array("- ","\n","\n"), $texte_final);
    $texte_final = supprimer_tags($texte_final);

    // On formate pour les accents
    // Texte a mettre en base
    $texte = filtrer_entites($texte);

    // On va vérifie s'il y a des pièces jointes
    $pj_enregistrees_nom = _request('pj_enregistrees_nom');
    $pj_enregistrees_mime = _request('pj_enregistrees_mime');
    $pj_enregistrees_extension = _request('pj_enregistrees_extension');
    $repertoire_temp_pj = _DIR_TMP.'/contact_pj/';

    // Si oui on les ajoute avec le plugin Facteur
    if ($pj_enregistrees_nom != null) {
        //On rajoute des sauts de ligne pour différencier du message.
        $texte_final = array(
        'texte' => $texte_final
        );
        foreach ($pj_enregistrees_nom as $cle => $nom_pj) {
               $texte_final['pieces_jointes'][$cle] = array(
               'chemin' => $repertoire_temp_pj.$nom_pj,
               'nom' => $nom_pj,
               'encodage' => 'base64',
               'mime' => $pj_enregistrees_mime[$cle]
               );
        }
    }

    // Enregistrement des messages en base de données si on l'a demandé
    if (lire_config('contact/sauvegarder_contacts')) {
        // Il s'agit d'un visiteur : on va donc l'enregistrer dans la table auteur pour garder son mail.
        // Sauf s'il existe déjà.
        $id_aut = sql_getfetsel(
            'id_auteur',
            'spip_auteurs',
            'email = '.sql_quote($posteur['mail'])
        );
        if (!$id_aut) {
               $nom_auteur = trim(_request('prenom').' '._request('nom'));
            if (!$nom_auteur) { $nom_auteur = $posteur['mail'];
            }
               $id_aut = sql_insertq(
                   'spip_auteurs',
                   array(
                   'nom' => $nom_auteur,
                   'email' => $posteur['mail'],
                   'statut' => 'contact'
                   )
               );

               // Ici on importe le tiers dans Dolibarr
            if (lire_config('dolispip_tiers/importer_selon_message')) {

                      $thirdparty = load_thirdparty_array();

                      $thirdparty['id'] = '0';
                      $nom_auteur = trim(_request('prenom').' '._request('nom'));
                      $organisation = _request('organisation') ? _request('organisation') .' '. $nom_auteur: $nom_auteur;
                if(!$organisation) { $organisation = $posteur['mail'] . ' - ' .$nom_auteur;
                }
                      $thirdparty['ref']=$organisation;

                      $thirdparty['client']="2";// 1=client 2=prospect, 3=prospect/client

                      $thirdparty['address']= _request('adresse');
                      $thirdparty['zip']=_request('code_postal');
                      $thirdparty['town']= _request('ville');

                      $thirdparty['country_code']=_request('pays');

                      $thirdparty['phone']=_request('telephone');
                      $thirdparty['fax']=_request('fax');
                      $thirdparty['email']=_request('mail');
                      $thirdparty['url']=_request('url');

                      $socid = dolispip_tiers_creer_fiche($thirdparty);

                if($socid > 0) {
                    // Update du doli_socid de la table auteur
                    sql_updateq('spip_auteurs', array('doli_socid' => $socid), 'id_auteur='.intval($id_aut));
                }

            }

        }

        // Ensuite on ajoute le message dans la base
        $id_message = sql_insertq(
            'spip_messages',
            array(
            'titre' => $posteur['sujet'],
            'statut' => 'publie',
            'type' => 'contac',
            'id_auteur' => $id_aut,
            'date_heure' => date('Y-m-d H:i:s'),
            'texte' => $texte,
            'rv' => 'non'
            )
        );

        // S'il y a des pièces jointes on les ajoute aux documents de SPIP.
        if ($pj_enregistrees_nom != null) {
               //On charge la fonction pour ajouter le document là où il faut
               $ajouter_documents = charger_fonction('ajouter_documents', 'action');
               $files[] = array('tmp_name'=>$repertoire_temp_pj.$nom_pj,'name'=>$nom_pj);
            foreach ($pj_enregistrees_nom as $nom_pj) {
                $id_doc = $ajouter_documents("new", $files, 'message', $id_message, 'document');
            }
        }

        // On lie le message au(x) destinataire(s) concerné(s)
        foreach ($destinataire as $id_destinataire) {
             sql_insertq(
                 'spip_auteurs_liens',
                 array(
                 'id_auteur' => $id_destinataire,
                 'id_objet' => $id_message,
                 'objet' => 'message',
                 'vu' =>'non')
             );
        }

        $memoire = generer_url_ecrire('message', 'id_message='.$id_message);
        if ($pj_enregistrees_nom != null) {
             $texte_final['texte'] .= "\n\n"._T('contact:consulter_memoire')."\n".$memoire;
        }
        else{
             $texte_final .= "\n\n"._T('contact:consulter_memoire')."\n".$memoire;
        }
    }
    // envoyer le mail maintenant
    if (!is_array($texte_final)) {
        $texte_final = array(
        'texte' => $texte_final
        );
    }
    $texte_final['repondre_a'] = $posteur['mail'];

    $envoyer_mail = charger_fonction('envoyer_mail', 'inc');
    $envoyer_mail($mail, $posteur['sujet'], $texte_final , '', "X-Originating-IP: ".$GLOBALS['ip']);

    // Maintenant que tout a été envoyé ou enregistré, s'il y avait des PJ il faut supprimer les fichiers
    if ($pj_enregistrees_nom != null) {
        foreach ($pj_enregistrees_nom as $cle => $nom_pj) {
            unlink($repertoire_temp_pj.$nom_pj);
        }
    }

    $message = _T('contact:succes', array("equipe_site" => $nom_site));
    return array('message_ok'=>$message);
}

include_spip('auth/sha256.inc');

// a partir de SPIP 2.1 il faut crypter les pass en sha256 a l place du md5 des version precedentes
// commit de creation de la version 2.1: 14864 cf
// http://core.spip.org/projects/spip/repository/revisions/14864
function dolispip_crypt_pass($input) 
{
    global $spip_version_code;

    if ($spip_version_code < 14864) {
        return md5($input);
    } else { return sha256($input);
    }
}

function dolispip_get_infos_tiers($idThirdparty, $use_user=false) 
{
    $endpoint = 'thirdparties/'.$idThirdparty;
    $res = getDolibarrApi($endpoint);
    return $res;
}


function dolispip_get_infos_contact($idContact, $use_user=false) 
{
    $endpoint = 'contacts/'.$idContact;
    $res = getDolibarrApi($endpoint);
    return $res;
}


/*
 *
* Retourne un objet à convertir en tableau si besoin avec get_object_vars()
*
*/
function dolispip_get_infos_user($idUser = '', $login = "", $useGenericUser=false) 
{

    $endpoint = 'users/'.$idUser;
    $res = getDolibarrApi($endpoint);
    return $res;
}


function dolispip_search_users_login($login) 
{
    $endpoint = 'users';
    $params = array('sqlfilters' => "t.login like '$login'");
    $res = getDolibarrApi($endpoint, $params, true, true);
    if($res->info->http_code == 200) {
        $resp = $res->decode_response();
        if(count($resp) > 1 ) {
            $return = $resp[0]->id;
        }
    }
    return $return;
}

function dolispip_search_users_email($email) 
{
    $return = '';
    $endpoint = 'users';
    $params = array('sqlfilters' => "t.email like '$email'");
    $res = getDolibarrApi($endpoint, $params, true, true);
    if($res->info->http_code == 200) {
        $resp = $res->decode_response();
        if(count($resp) > 1 ) {
            $return = $resp[0]->id;
        }
    }
    return $return;
}

function dolispip_search_thirdparties_email($email) 
{
    $return = '';
    $endpoint = 'thirdparties';
    $params = array('sqlfilters' => "t.email like '$email'");
    $res = getDolibarrApi($endpoint, $params, true, true);
    if($res->info->http_code == 200) {
        $resp = $res->decode_response();
        if(count($resp) > 1 ) {
            $return = $resp[0]->id;
        }
    }
    return $return;
}

function dolispip_search_contacts_email($email) 
{
    $return = '';
    $endpoint = 'contacts';
    $params = array('sqlfilters' => "t.email like '$email'");
    $res = getDolibarrApi($endpoint, $params, true, true);
    if($res->info->http_code == 200) {
        $resp = $res->decode_response();
        if(count($resp) > 1 ) {
            $return = $resp[0]->id;
        }
    }
    return $return;
}
/*
 * Charge le tableau d'un objet SOAP thirdparty
 */
function load_thirdparty_array() 
{
    $thirdparty = array();

    $thirdparty['id'] = '0';
    //$nom_auteur = trim(_request('prenom').' '._request('nom'));
    //$organisation = _request('organisation') ? _request('organisation') .' '. $nom_auteur: $nom_auteur;
    //if(!$organisation) $organisation = $posteur['mail'] . ' - ' .$nom_auteur;
    $thirdparty['ref']='';
    $thirdparty['ref_ext']="";
    $thirdparty['fk_user_author'] = '';
    $thirdparty['status'] = "1";
    $thirdparty['client']="2";// 1=client 2=prospect, 3=prospect/client
    $thirdparty['supplier']="";
    $thirdparty['customer_code']=""; // TODO : check API compat
    $thirdparty['supplier_code']=""; // TODO : check API compat
    $thirdparty['code_client']="auto";
    $thirdparty['code_fournisseur']="auto";
    $thirdparty['customer_code_accountancy']="";
    $thirdparty['supplier_code_accountancy']="";
    $thirdparty['date_creation'] = '';
    $thirdparty['date_modification'] = '';
    $thirdparty['note']="";
    $thirdparty['address']= '';
    $thirdparty['zip']= '';
    $thirdparty['town']= '';

    $thirdparty['country_id']="";
    $thirdparty['country_code']='';
    $thirdparty['country']="";
    $thirdparty['province_id']="";

    $thirdparty['phone']='';
    $thirdparty['fax']='';
    $thirdparty['email']='';
    $thirdparty['url']='';
    $thirdparty['profid1']="";
    $thirdparty['profid2']="";
    $thirdparty['profid3']="";
    $thirdparty['profid4']="";
    $thirdparty['profid5']="";
    $thirdparty['profid6']="";

    $thirdparty['capital']="";

    $thirdparty['barcode']="";
    $thirdparty['vat_used']="1";
    $thirdparty['vat_number']="";

    $thirdparty['note_private']="";
    $thirdparty['note_public']="";



    return $thirdparty;
}


function load_contact_array() 
{

    $contact = array();

    $contact['id'] = '';
    $contact['ref_ext'] = _request('ref_ext');
    $contact['lastname'] = _request('lastname');
    $contact['firstname'] = _request('firstname');
    $contact['address'] = _request('address');
    $contact['zip'] = _request('zip');
    $contact['town'] = _request('town');

    $contact['state_id'] = _request('state_id');
    $contact['state_code'] = _request('state_code');
    $contact['state'] = _request('state');

    $contact['country_id'] = '';
    $contact['country_code'] = _request('pays');
    $contact['country'] = '';

    $contact['socid'] = session_get('doli_socid');

    $contact['status'] =1;
    $contact['statut'] = 1; // deprecated
    $contact['phone_pro'] = '';
    $contact['fax'] = _request('fax');
    $contact['phone_perso'] = _request('phone_perso');
    $contact['phone_mobile'] = _request('phone_mobile');

    $contact['code'] = '';
    $contact['email'] = _request('email');

    $contact['birthday'] = '';
    $contact['default_lang'] = '';
    $contact['note'] = '';
    $contact['no_email'] = '';
    $contact['ref_facturation'] = '';
    $contact['ref_contrat'] = '';
    $contact['ref_commande'] = '';
    $contact['ref_propal'] = '';
    $contact['user_id'] = '';
    $contact['user_login'] = '';
    $contact['civility_id'] = '';
    $contact['poste'] = '';

    return $contact;
}

/**
 * Charge les saisies pour le formulaire de contact
 */
function load_saisies_dolicontact() 
{
    $saisies = array(
        array( // le fieldset
            'saisie' => 'fieldset',
            'options' => array(
                'nom' => 'coordonnees',
                'label' => 'Coordonnées'
                //'explication' => _T('explication_remise_hebergement')
            ),
            'saisies' => array( // les champs dans le fieldset
                array( // champ nom
                    'saisie' => 'input',
                    'options' => array(
                        'nom' => 'lastname',
                        'label' => _T('dolispip_tiers:nom'),
                        'obligatoire' => 'oui'
                    )
                ),
                array( // champ prénom
                    'saisie' => 'input',
                    'options' => array(
                        'nom' => 'firstname',
                        'label' => _T('dolispip_tiers:prenom')
                    )
                ),
                array( // champ email
                    'saisie' => 'email',
                    'options' => array(
                        'nom' => 'email',
                        'label' => _T('dolispip_tiers:adresse_email'),
                        'obligatoire' => 'oui'
                    )
                ),
                array( // champ adresse
                    'saisie' => 'textarea',
                    'options' => array(
                        'nom' => 'address',
                        'label' => _T('dolispip_tiers:adresse'),
                        'cols' => 80,
                        'rows' => 3
                    )
                ),
                array( // champ zip
                    'saisie' => 'input',
                    'options' => array(
                        'nom' => 'zip',
                        'label' => _T('dolispip_tiers:code_postal')
                    )
                ),
                array( // champ ville
                    'saisie' => 'input',
                    'options' => array(
                        'nom' => 'town',
                        'label' => _T('dolispip_tiers:ville')
                    )
                ),
                array( // champ pays
                    'saisie' => 'pays',
                    'options' => array(
                        'nom' => 'pays',
                        'label' => _T('pays:pays'),
                        'defaut' => '70'
                    )
                ),
                array( // champ tel pro
                    'saisie' => 'input',
                    'options' => array(
                        'nom' => 'phone_pro',
                        'label' => _T('dolispip_tiers:telephone_pro'),
                        'obligatoire' => 'non'
                    )
                ),
                array( // champ mobile
                    'saisie' => 'input',
                    'options' => array(
                        'nom' => 'phone_mobile',
                        'label' => _T('dolispip_tiers:telephone_mobile'),
                        'obligatoire' => 'non'
                    )
                )
            )
        ),
        /* TODO : créer un compte utilisateur
         array( // le fieldset
             'saisie' => 'fieldset',
             'options' => array(
                 'nom' => 'compte_user',
                 'label' => _T('dolispip_tiers:creer_un_compte_utilisateur'),
                 'explication' => _T('dolispip_tiers:explication_creation_login_contact')
             ),

             'saisies' => array( // les champs dans le fieldset
                 array( // champ nom
                     'saisie' => 'input',
                     'options' => array(
                         'nom' => _T('dolispip_tiers:login_pseudo_contact'),
                         'label' => _T('dolispip_tiers:login_pseudo')
                     )
                 )
             )
         )
    */
    );

    return $saisies;
}


function dolispip_tiers_creer_contact($contact) 
{
    include_spip('inc/dolispip');
    $endpoint = 'contacts';
    $res = postDolibarrApi($endpoint, $contact);
    return $res;
}

function dolispip_tiers_update_contact($idContact, $contact_array) 
{
    $endpoint = 'contacts/'.$idContact;
    $res = putDolibarrApi($endpoint, $contact_array);
    return $res;
}


function dolispip_tiers_update_tiers($idThirdparty,$thirdparty_array) 
{
    $endpoint = 'thirdparties/'.$idThirdparty;
    $res = putDolibarrApi($endpoint, $thirdparty_array);
    return $res;
}

/**
 * Get groups list
 */
function dolispip_get_list_groups() 
{
    include_spip('inc/dolispip');
    $endpoint = 'groups';
    return getDolibarrApi($endpoint, array(), true);
}

/**
 * Get Thirdparty information
 */
function dolispip_get_infos_thirdparty($idSociete) 
{
    include_spip('inc/dolispip');

    $endpoint = 'thirdparties/'.$idSociete;
    $res = getDolibarrApi($endpoint);
    return $res;
}

/**
 * Get contacts list
 */
function dolispip_get_list_contacts() 
{
    include_spip('inc/dolispip');
    $endpoint = 'contacts';
    return getDolibarrApi($endpoint);
}
