<?php
/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
*                                                                         *
*  Copyright (c) 2001-2008                                                *
*  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
*                                                                         *
*  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
*  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/

if (!defined("_ECRIRE_INC_VERSION")) { return;
}


// ajouter un champ doli_socid sur le formulaire CVT editer_auteur
function dolispip_tiers_editer_contenu_objet($flux)
{
    if ($flux['args']['type']=='auteur') {
        $flux['args']['contexte']['doli_socid'] = sql_getfetsel('doli_socid', 'spip_auteurs', 'id_auteur='.sql_quote($flux['args']['contexte']['id_auteur']));
        $ps = recuperer_fond('formulaires/inc-auteurs-dolispip', $flux['args']['contexte']);
        $flux['data'] = preg_replace('%(<!--extra-->)%is', $ps."\n".'$1', $flux['data']);
    }
    return $flux;
}

// ajouter le doli_socid soumis soumis lors de la soumission du formulaire CVT editer_auteur
function dolispip_tiers_pre_edition($flux)
{
    if ($flux['args']['table']=='spip_auteurs') {
        if ($ps = _request('doli_socid')) {
            $flux['data']['doli_socid'] = corriger_caracteres($ps);
        }
    }
    return $flux;
}


// ajouter le champ doli_socid sur la visualisation des auteurs
function dolispip_tiers_afficher_contenu_objet($flux)
{
    if ($flux['args']['type']=='auteur') {
        $ps = recuperer_fond('prive/squelettes/contenu/inc-auteur-dolispip', $flux['args']['contexte']);
        $flux['data'] .= "\n".$ps;
    }
    return $flux;
}

function dolispip_tiers_affiche_gauche($flux) 
{
    include_spip('inc/presentation');
    
    if ($flux['args']['exec'] == 'message') {
        $flux['data'] .= debut_cadre_relief('', true, '', _T('dolispip_tiers:import_dolibarr')) .
        recuperer_fond('prive/squelettes/import_message', array('id_message'=>$flux['args']['id_message'])) .
        fin_cadre_relief(true);

    }
    return $flux;
}


// La CSS pour le formulaire de création de compte & autre
function dolispip_tiers_insert_head_css($flux)
{
    $css = find_in_path('css/dolispip_tiers.css');
    $flux .= "<link rel='stylesheet' type='text/css' media='all' href='$css' />\n";
    return $flux;
}

// La CSS pour l'espace prive
function dolispip_tiers_header_prive($flux)
{
    $css = find_in_path('css/dolispip_tiers_prive.css');
    $flux .= "<link rel='stylesheet' type='text/css' media='all' href='$css' />\n";
    return $flux;
}

function dolispip_tiers_dolispip_config_menu($flux) {
    $contexte = $flux['args'];
    $_fond = 'prive/squelettes/inclure/dolispip_menu_config_tiers';
    $html = recuperer_fond($_fond, $contexte);
    $flux['data'] .= $html;
    return $flux;
}
