<?php

// Sécurité
if (!defined('_ECRIRE_INC_VERSION')) { return;
}


function formulaires_dolispip_creer_tier_charger_dist()
{

    include_spip('inc/session');

    $contexte = array(
    'particulier'=>'',
    'nom_societe'=>'',
    'nom' => $_SESSION['nom_auteur'],
    'prenom'=>'',
    'login'=>'',
    'address' => '',
    'zip' => '',
    'ville' => '',
    'pays' => '',
    'phone'=>'',
    'fax'=>'',
    'email'=>'',
    'url_site'=>'',
    'profid1'=>'',
    'vat_number'=>'',
    'pass'=>'',
    'pass_verif'=>'',
    '_etapes' => 2

    );

    return $contexte;
}

function formulaires_dolispip_creer_tier_verifier_1_dist()
{
    $erreurs = array();
    include_spip('base/abstract_sql');


    // Vérifier l'adresse email
    $verifier = charger_fonction('verifier', 'inc/');
    $verif_mail = $verifier(_request('email'), 'email',array('mode' => 'normal'));
    if($verif_mail != "") {
        $erreurs['email'] = $verif_mail;
    }

    // On regarde si l'email est déjà en base
    $id_auteur = sql_fetsel('id_auteur', 'spip_auteurs', "email=".sql_quote(_request('email'))." AND source='dolibarr'");
    if($id_auteur > 0) {
        // TODO : url
        $erreurs['email'] = _T('dolispip_tiers:erreur_compte_site_existant_avec_email');
    }

    $userEmailExists = dolispip_search_users_email(_request('email'));
    //var_dump($userEmailExists); exit;

    if ($erreurs) {
        $erreurs['message_erreur'] = _T('dolispip_tiers:erreur_saisie');

    }

    return $erreurs;
}

function formulaires_dolispip_creer_tier_verifier_2_dist()
{

    $erreurs = array();
    include_spip('base/abstract_sql');
    $verifier = charger_fonction('verifier', 'inc/');

    $obligatoires = array('nom','address','zip','ville', 'email', 'login', 'pass', 'pass_verif');
    foreach($obligatoires as $champ) {
        if (!_request($champ)) {
            $erreurs[$champ] = _T('dolispip_tiers:erreur_info_obligatoire');
        }
    }

    if(_request('particulier') == '0' && !_request('nom_societe')) {
        $erreurs['particulier'] = "Renseignez le nom de votre entreprise/association";
    }

    // Login maxi 24 caractères
    $verif_longueur_login = $verifier(_request('login'), 'taille', array('max' => 24));
    if(strlen($verif_longueur_login) > 0) {
        $erreurs['login'] = $verif_longueur_login;
    }

    // On regarde si un auteur a le même login
    $id_auteur = sql_fetsel('id_auteur', 'spip_auteurs', "login=".sql_quote(_request('login')));
    if($id_auteur) {
        $erreurs['login'] = _T('dolispip_tiers:erreur_compte_existant_identifiant');
    }

    // Check into webservice if user exists
    $userapi = dolispip_search_users_login(_request('login'));
    var_dump($userapi); exit;
    if((int) $userapi->id > 0) {
        $erreurs['login'] = _T('dolispip_tiers:erreur_compte_existant_identifiant');
    }

    // Vérifier les mots de passe
    if(_request('pass') != _request('pass_verif')) {
        $erreurs['pass_verif'] = _T('dolispip_tiers:erreur_pass_identiques');
    }
    else {

        //Mot de passe minimum 6 caractères
        // TODO :  lettres et chiffres
        $verif_pass = $verifier(_request('pass'), 'taille', array('min' => 6));
        if(strlen($verif_pass) > 0) {
            $erreurs['pass'] = $verif_pass;
        }
    }

    if ($erreurs) {
        $erreurs['message_erreur'] = _T('dolispip_tiers:erreur_saisie');

    }

    return $erreurs;
}

function formulaires_dolispip_creer_tier_traiter_dist()
{
    include_spip('inc/config');
    include_spip('inc/utils');
    $retours = array();

    $thirdparty = load_thirdparty_array();

    $thirdparty['name_thirdparty'] = _request('nom_societe') ? _request('nom_societe') : _request('nom') ." ". _request('prenom');
    $thirdparty['name'] = _request('nom');
    $thirdparty['firstname'] = _request('prenom');
    $thirdparty['particulier'] = _request('particulier');
    $thirdparty['ref_ext'] = '';
    $thirdparty['address'] = _request('address');
    $thirdparty['zip'] = _request('zip');
    $thirdparty['town'] = _request('ville');
    $thirdparty['country_id'] = '';
    $thirdparty['country_code'] = _request('pays');
    $thirdparty['phone'] = _request('phone');
    $thirdparty['phone_mobile'] = _request('phone_mobile');
    $thirdparty['fax'] = _request('fax');
    $thirdparty['email'] = _request('email');
    $thirdparty['url'] = _request('url_site');
    $thirdparty['idprof1'] = _request('profid1'); // SIREN
    $thirdparty['idprof2'] = _request('profid2'); // SIRET
    $thirdparty['idprof3'] = _request('profid3'); // NAF
    $thirdparty['idprof4'] = _request('profid4'); // RCS
    $thirdparty['idprof6'] = _request('profid5');
    $thirdparty['idprof37'] = _request('profid6');
    $thirdparty['capital'] = _request('capital');
    $thirdparty['tva_assuj'] = _request('vat_used');
    $thirdparty['tva_intra'] = _request('vat_number');

    $thirdparty['client']=lire_config('dolispip_tiers/type_tiers_defaut', '1'); // 1=client 2=prospect, 3=prospect/client
    $thirdparty['fournisseur']="0";

    $thirdparty['login'] = _request('login');
    $thirdparty['password'] = _request('pass');
    $thirdparty['group_id'] = lire_config('dolispip_tiers/group_for_users');

    $tier = false;

    /*
    *  Création du compte client : le webservice sur Dolibarr se charge de créer les contacts à partir des infos du formulaire
    * 	Si l'adresse email est en base on récupère son id_soc
    */
    $tier = dolispip_tiers_creer_compte($thirdparty);
    if($tier > 0 ) {
        // Création du compte client réussi
        $ok = true;

        // Association compte client dolibarr <> auteur spip
        // ...
        $champs = array(
         'nom' => $thirdparty['firstname'].' '.$thirdparty['name'],
         'email'=> $thirdparty['email'],
         'url_site' => $thirdparty['url'],
         'login'=> $thirdparty['login'],
         'statut'=> lire_config('dolispip/statutclients_spip_dolibarr'),
         'source'=> 'dolibarr',
         'doli_socid'=> $tier
         );

        // Enregistre les infos dans SPIP
        $id_auteur = sql_insertq('spip_auteurs', $champs, 0);


        // Invalider les caches
           include_spip('inc/invalideur');
           suivre_invalideur("id='id_auteur/$id_auteur'");

           /*
            * Envoyer un mail à l'admin et à l'internaute
           */
        if ($notifications = charger_fonction('notifications', 'inc')) {
            $notifications('creation_compte', $id_auteur,
            array('id_tier' => $tier,'thirdparty' => $thirdparty));
        }

        // Connecter automagiquement à la création du compte
        if (lire_config('dolispip_tiers/forcer_authentification')) {
                include_spip('inc/auth');
                   $auteur = auth_identifier_login($thirdparty['login'], $thirdparty['password']);

            if ($auteur) {
                auth_loger($auteur);
            }
        }

        if ($ok) {
             $redirect = _request('redirect');

             $retours['message_ok'] = _T('dolispip_tiers:creation_compte_reussie');
             //$retours['editable']=false;
             //$retours['redirect'] = ( $GLOBALS['meta']['type_urls'] == 'arbo' ? '/client/moncompte.php?create=ok&amp;var_login='.$thirdparty['login'].'&amp;redirect='.$redirect : generer_url_public('moncompte','id_doli='.$result['id'],true) );
            if($redirect) {
                $retours['redirect'] = $redirect;
            }
        }
        else {
             $retours['message_erreur'] = _T('dolispip_tiers:creation_compte_erreur');
        }
    }
    elseif($tier == 0 ) {
        $retours['message_erreur'] = _T('dolispip_tiers:creation_compte_erreur_contact_existant');
    }
    elseif($tier < 0 ) {
        $retours['message_erreur'] = _T('dolispip_tiers:creation_compte_erreur_contactez_nous');
    }

    return $retours;
}
