<?php

// Sécurité
if (!defined('_ECRIRE_INC_VERSION')) { return;
}


function formulaires_dolispip_update_tiers_charger_dist($id)
{

    include_spip('inc/session');
    // Charge les infos du tiers
    $thirdparty_array = dolispip_get_infos_tiers($id, 1);
    $thirdparty_old = $thirdparty_array;

    if(is_object($thirdparty_array)) {
        $contexte = array(
         'id' =>$thirdparty_old->id,
         'nom_societe' => $thirdparty_old->name,
         'address' => $thirdparty_old->address,
         'zip' => $thirdparty_old->zip,
         'town' => $thirdparty_old->town,
         'pays' => $thirdparty_old->country_code,
         'phone'=>$thirdparty_old->phone,
         'fax'=>$thirdparty_old->fax,
         'email'=> $thirdparty_old->email,
         'url'=> $thirdparty_old->url

         //	'_etapes' => 2

        );
    }
    else {
        $contexte = array(
         'editable' => false,
         'message_erreur' => 'interdit !!'
        );
    }

    return $contexte;
}

function formulaires_dolispip_update_tiers_verifier_dist($id)
{
    $erreurs = array();
    include_spip('base/abstract_sql');


    // Vérifier l'adresse email si renseignée
    if(_request('email') != '') {
        $verifier = charger_fonction('verifier', 'inc/');
        $verif_mail = $verifier(_request('email'), 'email',array('mode' => 'normal'));
        if($verif_mail != "") {
            $erreurs['email'] = $verif_mail;
        }
    }

    $obligatoires = array('nom_societe','address','zip','town');
    foreach($obligatoires as $champ) {
        if (!_request($champ)) {
            $erreurs[$champ] = "Cette information est obligatoire !";
        }
    }


    return $erreurs;
}


function formulaires_dolispip_update_tiers_traiter_dist($id)
{
    include_spip('inc/config');
    include_spip('inc/utils');
    include_spip('inc/session');
    $retours = array();


    $thirdparty = load_thirdparty_array();

    $thirdparty['id'] = $id;
    // Don't let users editing company name
    //$thirdparty['name'] = _request('nom_societe');

    $thirdparty['address'] = _request('address');
    $thirdparty['zip'] = _request('zip');
    $thirdparty['town'] = _request('town');

    $thirdparty['socid'] = session_get('doli_socid');
    $thirdparty['country_code'] = _request('pays');
    $thirdparty['phone'] = _request('phone');

    $thirdparty['fax'] = _request('fax');
    $thirdparty['email'] = _request('email');
    $thirdparty['url'] = _request('url');



    $result = dolispip_tiers_update_tiers($id, $thirdparty);
    if((int) $result->id > 0 ) {

         $retours['message_ok'] = _T('dolispip_tiers:modif_tiers_reussie');

         include_spip('inc/invalideur');
         suivre_invalideur("dolitiers/$id");

    }
    elseif($result === 0 ) {
        $retours['message_erreur'] = "Contact déjà existant, veuillez nous contacter.";
    }
    elseif($result === false) {
        $retours['message_erreur'] = "Une erreur s'est produite, veuillez nous contacter.";
    }

    return $retours;
}
