<?php
/**
 * Notification de création de compte
 */

if (!defined("_ECRIRE_INC_VERSION")) {
    return;
}

/**
 * Notification de création de compte
 * 
 * @param string $quoi  Quoi?
 * @param int $id_auteur Auteur ID
 * @param array $options Tableau d'options
 * 
 * @return void
 */
function notifications_creation_compte_dist($quoi, $id_auteur, $options)
{

    include_spip('inc/config');
    include_spip('inc/utils');

    $destinataires = array();

    $modele = "notifications/creation_compte";

    $options['id_auteur'] = $id_auteur;

    /* Envoi du mail infos à l'admin
    */
    if(lire_config('dolispip_tiers/envoi_mail_creation_compte') == 'oui') {
        $modele_admin = "notifications/creation_compte_admin";
        $destinataires[]=$GLOBALS['meta']['email_webmaster'];
    }

    if ($modele) {

        $destinataires[] = $options['thirdparty']['email'];
        $texte = recuperer_fond($modele, $options);

        notifications_envoyer_mails($destinataires, $texte);

    }

    if ($modele_admin) {

        $texte = recuperer_fond($modele_admin, $options);
        notifications_envoyer_mails($destinataires, $texte_admin);

    }



}