<?php

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/dolispip');

/**
 * Get timebasket information
 *
 */
function dolispip_get_infos_timebasket($timebasketId) {
  $endpoint = 'timebaskets/'.$timebasketId;
  $res = getDolibarrApi($endpoint);
  return $res;
}

/**
 * Get timebasket list
 *
 */
function dolispip_get_list_timebasket() {
  $endpoint = 'timebaskets';
  return getDolibarrApi($endpoint);
}

/**
 * Get timebasket consumption list
 *
 */
function dolispip_get_list_timebasket_consommations($timebasketId=0) {
    $endpoint = 'timebasketconsumptions';
    if($timebasketId > 0) {
      $endpoint.="/timebasket/$timebasketId";
    }
    $res = getDolibarrApi($endpoint);
    return $res;
}

/**
 * Filter to convert a duration (in second) into a time duration.
 *
 */
function timebasket_affduree($duree=0)
{
  $is_negative = false;
  $is_negative = substr(strval($duree), 0, 1) == "-";
  if($is_negative) {
    $duree = abs($duree);
  }

  $temp = $duree % 3600;

  // Heure
  $time[0] = ( $duree - $temp ) / 3600 ;

  // jour
  $time[2] = $temp % 60 ;

  // Minutes
  $time[1] = ( $temp - $time[2] ) / 60;

  $final_string = '';
  if($is_negative) {
    $final_string.= '- ';
  }
  if($time[0] > 0) {
    $final_string.= $time[0].'h';
  }
  if($time[1] > 0) {
    $final_string.= $time[1].'mn';
  }

  //$time[0].'h '.$time[1].'m';
  return $final_string;
}
